uses crt,nwmisc,objects,
     nwiproc,nwitype;

var trustees:TNWColl;
    usernames:TNWUserColl;
    StaRest:TNWColl;
    VolRest:TNWColl;
    vol:TNWColl;
    Coll:TNWColl;
    i,j,v:integer;
    volname:string;
    user:string;
    userID:longint;
    c:char;
    parameter:string;
    screen:text;
begin
  if paramstr(1) = '' then Gethelp;
  parameter:=paramstr(1);
  upstring(parameter);
  if pos(parameter,'0')>0 then parameter:='AGRMNSVTLP';
  assign(output,''); rewrite(output);

  assigncrt(screen);
  rewrite(screen);

  trustees.init(1,1);
  StaRest.init(1,1);
  VolRest.init(1,1);
  usernames.init(1,1);
  vol.init(1,1);
  coll.init(1,1);

  getuser(usernames);
  getVolumes(vol);

  for i:=1 to usernames.count do
    begin
{ KOPF }
      writeln('   ͻ');
      user:=usernames.getstr(i,0); userid:=usernames.getid(i);
      writeln('    ',LeftStr(user,28),'(',hexdumpstr(userid,8),')',RightStr(getRealName(user),28),' ');
      writeln('   ͼ');

      if pos('C',parameter)>0 then writeln(screen,user);

      if pos('A',parameter)>0 then begin
        writeln(^j'Account Information:');
        getaccount(user);
      end;

      if pos('G',parameter)>0 then begin
        write(^j'Groups belonged to: ');
        getprop(user,'GROUPS_I''M_IN',coll);
        coll.showstrlist;
      end;

      if pos('M',parameter)>0 then
        writeln('Managed Users/Groups: ',getmanaged(user));

      if pos('N',parameter)>0 then begin
        write('Managers: ');
        getprop(user,'OBJ_SUPERVISORS',coll);
        coll.showstrlist;
      end;

      if pos('S',parameter)>0 then begin
        write('Security equivalences: ');
        getprop(user,'SECURITY_EQUALS',coll);
        coll.showstrlist;
      end;

      if pos('R',parameter)>0 then begin
        write(^j'Station restrictions:');
        StaRest.freeall;
        getnoderes(user,StaRest);
        if StaRest.count=0 then
          writeln(' <none>')
        else begin
          writeln;
          v:=0;
          for j:=0 to StaRest.count-1 do begin
            inc(v);
            if v=3 then begin writeln; v:=1 end;
            write('     ',pstring(StaRest.at(j))^);
          end;
          writeln;
        end;
      end;

      if pos('V',parameter)>0 then begin
        writeln(^j'Volume restrictions:');
        VolRest.freeall;
        getVolumeRestrictions(userID, vol, VolRest);
        for j:=0 to VolRest.count-1 do
          writeln('     ',pstring(VolRest.at(j))^);
      end;

      if pos('T',parameter)>0 then begin
        { Get Trustee for each USER }
        writeln(^j'Trustee Directory Assignments');
        trustees.freeall;
        for v:=1 to vol.count do
          getusertrustees(v-1,pNWUser(usernames.at(i-1))^.id,trustees);
        if trustees.count=0 then
          writeln('     <none>')
        else
          for j:=0 to trustees.count-1 do
            writeln('     ',pstring(trustees.at(j))^);
      end;


      if pos('L',parameter)>0 then begin
        writeln(^j'Login Script');
        getLoginScript(userid);
      end;

      if pos('P',parameter)>0 then begin
        write(#12); { newpage }
      end;
    end;

  trustees.done;
  usernames.done;
  vol.done;
  StaRest.done;
  VolRest.done;
  coll.done;
end.
